﻿using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;
using System.Runtime.Serialization.Formatters.Binary;

namespace Murashki
{
    public partial class Form1 : Form
    {
        ArrayList a = new ArrayList();

        public Form1()
        {
            InitializeComponent();
        }

        private void exitToolStripMenuItem_Click(object sender, EventArgs e)
        {
            
            if ( MessageBox.Show("Закрыть?",
                                 "Мурашки",
                                 MessageBoxButtons.YesNo,
                                 MessageBoxIcon.Question) == DialogResult.Yes)
                        Close();
        }

        private void panel1_Paint(object sender, PaintEventArgs e)
        {
            foreach (Figures f in a) f.Paint(e.Graphics);
        }

        private void panel1_MouseClick(object sender, MouseEventArgs e)
        {
            if (e.Button == MouseButtons.Left)
                a.Add(new Circles(e.X, e.Y));
            else a.Add(new Square(e.X, e.Y));

            panel1.Invalidate();
        }

        private void timer1_Tick(object sender, EventArgs e)
        {
            foreach (Figures f in a) f.Move(panel1.Size);
            panel1.Invalidate();
        }

        private void startToolStripMenuItem_Click(object sender, EventArgs e)
        {
            timer1.Enabled = true;
        }

        private void stopToolStripMenuItem_Click(object sender, EventArgs e)
        {
            timer1.Enabled = false;
        }

        private void button1_Click(object sender, EventArgs e)
        {
            if (timer1.Interval>20) timer1.Interval -= 10;

        }

        private void button2_Click(object sender, EventArgs e)
        {
            timer1.Interval += 10;
        }

        private void SaveToolStripMenuItem_Click(object sender, EventArgs e)
        {
            SaveFileDialog D = new SaveFileDialog();
            D.DefaultExt = "bin";
            D.FileName = "save";
            D.Filter = "Binary files (*.bin)|*.bin|All files (*.*)|*.*";
            D.FilterIndex = 1;
            D.InitialDirectory = ".";

            if (D.ShowDialog() == DialogResult.OK)
            {
                try
                {
                    FileStream F = new FileStream(D.FileName, FileMode.Create);
                    BinaryFormatter B = new BinaryFormatter();
                    B.Serialize(F, a);
                    F.Close();
                }
                catch(Exception err)
                {
                    MessageBox.Show(err.Message, "Мурашки 1.0",
                        MessageBoxButtons.OK,
                        MessageBoxIcon.Error);
                }
            }
        }

        private void OpenToolStripMenuItem_Click(object sender, EventArgs e)
        { // OPEN

            OpenFileDialog D = new OpenFileDialog();
            D.DefaultExt = "bin";
            D.FileName = "save";
            D.Filter = "Binary files (*.bin)|*.bin|All files (*.*)|*.*";
            D.FilterIndex = 1;
            D.InitialDirectory = ".";

            if (D.ShowDialog() == DialogResult.OK)
            {
                try
                {
                    FileStream F = new FileStream(D.FileName, FileMode.Open);
                    BinaryFormatter B = new BinaryFormatter();
                    a = (ArrayList)B.Deserialize(F);
                    F.Close();
                    panel1.Invalidate();
                }
                catch (Exception err)
                {
                    MessageBox.Show(err.Message, "Мурашки 1.0",
                        MessageBoxButtons.OK,
                        MessageBoxIcon.Error);
                }
            }

        }
    }
}
